###############################################################################
###############################################################################
##
##  Copyright (C) 2004-2006 Red Hat, Inc.  All rights reserved.
##
##  This copyrighted material is made available to anyone wishing to use,
##  modify, copy, or redistribute it subject to the terms and conditions
##  of the GNU General Public License v.2.
##
###############################################################################
###############################################################################
Source10: kmodtool
%define kmodtool bash %{SOURCE10}
%{!?kversion: %define kversion 2.6.18-194.3.1.el5}
# hint: this can he overridden with "--define kversion foo" on the rpmbuild command line, e.g.
# --define "kversion 2.6.16-1.2096_FC5"

%define kmod_name rt2860
%define kverrel %(%{kmodtool} verrel %{?kversion} 2>/dev/null)

%define upvar ""
%ifarch ppc
%define smpvar smp
%endif
%ifarch ia64
%define xenvar xen
#define kdumpvar kdump
%endif
%ifarch i686
%define PAEvar PAE
%endif
%{!?kvariants: %define kvariants %{?upvar} %{?smpvar} %{?xenvar} %{?kdumpvar} %{?PAEvar}}
# hint: this can he overridden with "--define kvariant foo bar" on the rpmbuild command line, e.g.
# --define 'kvariant "" smp' 
%define rt2860ver 2010_01_29_RT2860_Linux_STA_v2.3.0.0

Name:           %{kmod_name}-kmod
Version:        2.3.0.0
Release:        0.4%{?dist}
Summary:        %{kmod_name} kernel modules

Group:          System Environment/Kernel
License:        GPL
URL:            http://www.ralinktech.com/ralink/Home/Support/Linux.html
Source0:        http://www.ralinktech.com.tw/data/%{rt2860ver}.tar.bz2
Patch1:		rt2860-jpfixes.patch
Patch3:		rt2860-suppress-flood.patch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
ExclusiveArch:  i686 x86_64 ia64 ppc64 ppc64iseries s390x
# Temporarily disable s390 & ppc

%description
Ralink USB driver for 2860

# magic hidden here:
%{expand:%(%{kmodtool} rpmtemplate_kmp %{kmod_name} %{kverrel} %{kvariants} 2>/dev/null)}

%prep
# to understand the magic better or to debug it, uncomment this:
#{kmodtool} rpmtemplate %{kmod_name} %{kverrel} %{kvariants} 2>/dev/null
#sleep 5
%setup -q -c -T -a 0 -n %{rt2860ver}
pushd %{rt2860ver}
%patch1 -p1 -b .jpfixes
%patch3 -p1
popd
pwd
ls -la
for kvariant in %{kvariants} ; do
   # cp -a %{kmod_name}-kernel-%{version}/kernel _kmod_build_${kvariant}
    cp -a %{rt2860ver} _kmod_build_${kvariant}
done


%build
for kvariant in %{kvariants}
do
    ksrc=%{_usrsrc}/kernels/%{kverrel}${kvariant:+-$kvariant}-%{_target_cpu}
    pushd _kmod_build_$kvariant
    #make -C "${ksrc}" SUBDIRS=${PWD} modules %{?_smp_mflags}
    make LINUX_SRC=$ksrc
    popd
done


%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/etc/Wireless/RT2860STA
for kvariant in %{kvariants}
do
    pushd _kmod_build_$kvariant
    mkdir -p $RPM_BUILD_ROOT/lib/modules/%{kverrel}${kvariant}/extra/%{kmod_name}
    make install \
         LINUX_SRC_MODULE=$RPM_BUILD_ROOT/lib/modules/%{kverrel}${kvariant}/extra/%{kmod_name} \
	 DAT_PATH=$RPM_BUILD_ROOT/etc/Wireless/RT2860STA
    popd
done
# Temporarily executable for stripping, fixed later in %%files.
chmod u+x $RPM_BUILD_ROOT/lib/modules/*/extra/%{kmod_name}/*


%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root)
%dir /etc/Wireless
%dir /etc/Wireless/RT2860STA
/etc/Wireless/RT2860STA/RT2860STA.dat

%changelog
* Tue May 18 2010 Josko Plazonic <plazonic@math.princeton.edu>
- initial build of RT2860 on RHEL5
